using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;
using System.Diagnostics;

namespace TestProject
{
    /// <summary>
    /// 
    /// </summary>
    public class Startup
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Configuration

        /// <summary>
        /// 
        /// </summary>
        public IConfiguration Configuration { get; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Startup(configuration)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="configuration"></param>
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ÷ ϱ - ConfigureServices(services)

        /// <summary>
        ///  ÷ ϱ
        /// </summary>
        /// <param name="services"> ÷</param>
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddAuthorization();
        }

        #endregion
        #region ϱ - Configure(app, logger)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="app">ø̼ </param>
        /// <param name="logger">α ϱ</param>
        public void Configure(IApplicationBuilder app, ILogger<Startup> logger)
        {
            // ζ ̵ 1
            app.Use
            (
                next => async context =>
                {
                    Stopwatch stopwatch = Stopwatch.StartNew();

                    await next(context);

                    stopwatch.Stop();

                    logger.LogInformation($"TIME 1 : {stopwatch.ElapsedMilliseconds}ms");
                }
            );

            app.UseRouting();

            // ζ ̵ 2
            app.Use
            (
                next => async context =>
                {
                    Stopwatch stopwatch = Stopwatch.StartNew();

                    await next(context);

                    stopwatch.Stop();

                    logger.LogInformation($"TIME 2 : {stopwatch.ElapsedMilliseconds}ms");
                }
            );

            app.UseAuthorization();

            // ζ ̵ 3
            app.Use
            (
                next => async context =>
                {
                    Stopwatch stopwatch = Stopwatch.StartNew();

                    await next(context);

                    stopwatch.Stop();

                    logger.LogInformation($"TIME 3 : {stopwatch.ElapsedMilliseconds}ms");
                }
            );

            app.UseEndpoints
            (
                endpoints =>
                {
                    endpoints.MapGet
                    (
                        "/",
                        async context =>
                        {
                            await context.Response.WriteAsync("Timing test.");
                        }
                    );
                }
            );
        }

        #endregion
    }
}